--vegetation based scripts
require("Scripts/Vegetation/growth.lua")
--unit based scripts
require("Scripts/Units/update.lua")
--team based scripts
require("Scripts/Team/update.lua")
--building scripts
require("Scripts/Buildings/index.lua")

function createTeam(name, civ, pos, number)
	local team = {} -- need to figure out a team class description.
	team.name = name -- need to make a grammar for each civ.
	team.civ = civ --for doing all that lovely civ specific stuff.
	team.pos = pos --because we all need to start somewhere. form: {x,y}
	team.number = number
	team.units = {} --for unit AI iteration and such.
	team.totalunits = 0
	team.buildings = {}
	team.seentiles = {}
	--resources!
	team.wood = 50
	team.minerals = 0
	team.food = 500
	--for jobs later..
	team.tasks = {1,1,1,2,1,2,3,2,3,4,4,4}
	function team:update()
		updateTeam(self) --see Teams/update.lua
	end
	function team:destroy()
		for k,v in ipairs(self.units) do
			v:destroy()
		end
		for k,v in ipairs(self.buildings) do
			v:loss()
		end
		self = {}
		self = nil
		for k,v in ipairs(teamTable) do
			if v == self then
				teamTable[k] = nil
			end
		end
	end
	function team:getNumBuilding(name)
		local count = 0
		for k,v in ipairs(self.buildings) do
			if v.name == name then
				count = count + 1
			end
		end
		return count
	end
	function team:getNetAgressiveness()
		local count = 0
		for k,v in ipairs(self.units) do
			count = count + v.agressiveness()
		end
		return count / #self.units
	end
	teamTable[number] = team
	return team
end

function createTile(pos, alt, totalspace, ttype, kind, number, tag) --woo tiles have a class now
	local tile = {}
	tile.pos = pos
	tile.alt = alt
	tile.occupants = {}
	tile.totalspace = totalspace
	tile.type = ttype
	tile.kind = kind
	tile.number = number
	tile.tag = tag
	tile.cliffnum = 1
	tile.seen = {}
	function tile:getNeighbours()
		self.neighbours = {}
		for k,v in ipairs(worldTable) do
			if (v.pos[1] >= self.pos[1] - 1 and v.pos[1] <= self.pos[1] + 1) and
				(v.pos[2] >= self.pos[2] - 1 and v.pos[2] <= self.pos[2] + 1) and v ~= self then
				table.insert(self.neighbours, v)
			end
		end
	end
	function tile:insertOccupant(object)
		--remove it if necessary
		if object then --and object:canFit(self) then
			if object.tile ~= self then
				for k,v in pairs(object.tile.occupants) do
					if v == object then
						table.remove(object.tile.occupants, k)
						break
					end
				end
				--reinsert the object into self
				object.tile = self
				table.insert(self.occupants, object)
			end
			return true
		else
			return false
		end
	end
	table.insert(worldTable, tile)
	return tile
end

function createBuilding(name, class, space, team, tile)
	tile.tag = name --for pathing perhaps.
	local building = {}
	building.team = team --always good to have a team.
	building.name = name --printable name.
	building.sprite = math.random(#buildings[building.name]) --piccur to draw.
	building.space = space --how much space it takes up
	building.class = "BUILDING" --class declatarion type_kind
	building.type = class
	building.tile = tile --references own tile for derivative stats (pos etc)
	--for dynamic control
	building.ownershipmax = 1000
	building.ownership = building.ownershipmax
		---------------NEED TO FIGURE OUT HOW TO TAKE UP >1 SQUARE!~
	function building:interact(unit)
		return getBuildingInteractionFunction(self, unit)
	end
	function building:update()
		return getBuildingUpdateFunction(self)
	end
	function building:loss()
		for k,v in ipairs(teamTable[self.team].buildings) do
			if v == self then
				table.remove(teamTable[self.team].buildings, k); break
			end
		end
		self.team = 0
	end
	function building:destroy()
		for k,v in ipairs(self.tile.occupants) do
			if v == self then
				table.remove(self.tile.occupants, k); break
			end
		end
		for k,v in ipairs(teamTable[self.team].buildings) do
			if v == self then
				table.remove(teamTable[self.team].buildings, k); break
			end
		end
		for k,v in ipairs(worldTable.buildings) do
			if v == self then
				table.remove(worldTable.buildings, k); break
			end
		end
		print(self.name.." razed")
		self = {}
		self = nil
	end
	table.insert(tile.occupants, building)
	table.insert(teamTable[team].buildings, building)
	table.insert(worldTable.buildings, building)
	return building
end

function createUnit(name, class, space, team, tile, speed, range) ----======================================REMEMBER TO UPDATE REPRODUCTIVE COPY BELOW
	local unit = {}
	unit.team = team --always good to have a team.
	unit.name = name --printable name. --need to make grammars for random names
	unit.type = class --confusing var names, this is eco or mil.
	unit.space = space --how much space it takes up
	unit.class = "UNIT" --class declatarion
	unit.tile = tile --references own tile for derivative stats (pos etc)
	unit.gender = math.random(2) --1 = female, 2 = male --FOR BREEDING STUFF
	--set up timers & tables
	unit.lifetime = 0 --for timed stuff
	unit.seentiles = {}; tabRadius(tile, worldTable, range, unit.seentiles) --stupid me making unintuitive functions
	--tiles to move to
	unit.toMove = {tile}; aStarBetween(unit.tile, unit.seentiles[math.random(#unit.seentiles)], unit.seentiles, unit.toMove)
	--job int for setting tasks
	unit.job = 0
	unit.joblife = 0
	unit.delay = 0
	--resource carry
	unit.wood = 0
	unit.minerals = 0
	--genetic stuff
	unit.baseagressiveness = math.random(-2,2) --for battle
	unit.agressivenessmodifier = 0
	function unit.agressiveness() return unit.baseagressiveness + unit.agressivenessmodifier end
	unit.baseintelligence = math.random(-5,5) --for research
	unit.intelligencemodifier = 0
	function unit.intelligence() return unit.baseintelligence + unit.intelligencemodifier end
	unit.baselaziness = math.random(-1,1) --for job decisions
	unit.lazinessmodifier = 0
	function unit.laziness() return unit.baselaziness + unit.lazinessmodifier end
	unit.basecharisma = math.random(0,10) --for being social
	unit.charismamodifier = 0
	function unit.charisma() return unit.basecharisma + unit.charismamodifier end
	unit.basestrength = math.random(-5,5) --for battle
	unit.strengthmodifier = 0
	function unit.strength() return unit.basestrength + unit.strengthmodifier end
	unit.life = math.random(7200,12000) --genetic lifetime, will be much longer eventually.
	unit.speed = speed --for movement
	unit.range = range --for seeing and acting upon. limitations of AI :D
	unit.maxhp = math.floor(((unit.strength() * (math.log(unit.life,20) * (unit.laziness() + 1))) + 70 / 2))
	unit.hp = unit.maxhp * 2/3
	--relationships table for storing social data
	unit.relationships = {}
	
	--set up update function
	function unit:update()
		updateUnit(self)
	end
	function unit:attack(thing)
		local modifier = math.abs(self.hp) / self.maxhp * math.abs(self.agressiveness())
		if modifier > 0 then
			local attack = round(self.strength()^2 * modifier)
			if attack > 0 then
				thing.hp = thing.hp - attack
				print(self.name.." attacks "..thing.name.." for "..attack.." damage! "..thing.hp.."hp left.")
			end
			if thing.relationships[self.name] then
				thing.relationships[self.name] = thing.relationships[self.name] - thing.agressiveness() * math.random(3,12)
				thing.agressivenessmodifier = thing.agressivenessmodifier + (math.random(0,5) / 10)
			else
				thing.relationships[self.name] = thing.agressiveness() * math.random(3,12)
				thing.agressivenessmodifier = thing.agressivenessmodifier + (math.random(0,5) / 10)
			end
		end
	end
	function unit:canFit(tile) --check if a unit can fit in a tile
		if tile.space >= self.space then
			return true --yes, you can fit!
		end
		return false --hell no >_<
	end
	function unit:goTo(tile)
		if self:canFit(tile) then
			pathTo(self.tile, tile, worldTable, seentiles, self)
		end
	end
	function unit:destroy()
		for k,v in ipairs(self.tile.occupants) do
			if v == self then
				table.remove(self.tile.occupants, k); break
			end
		end
		for k,v in ipairs(teamTable[self.team].units) do
			if v == self then
				table.remove(teamTable[self.team].units, k); break
			end
		end
		for k,v in ipairs(worldTable.units) do
			if v == self then
				table.remove(worldTable.units, k); break
			end
		end
		print(self.name.." dead")
		self = {}
		self = nil
	end
	table.insert(tile.occupants, unit)
	table.insert(teamTable[unit.team].units, unit)
	teamTable[unit.team].totalunits = teamTable[unit.team].totalunits + 1
	table.insert(worldTable.units, unit)
	return unit
end

function createUnitReproduction(parent1, parent2, tile)
	local unit = {}
	unit.team = parent1.team --always good to have a team.
	unit.name = "unit_"..(teamTable[unit.team].totalunits).."_"..unit.team --printable name. --need to make grammars for random names
	unit.type = "ECO" --confusing var names, this is eco or mil.
	unit.space = (parent1.space + parent2.space) / 2 --how much space it takes up
	unit.class = "UNIT" --class declatarion
	unit.tile = tile --references own tile for derivative stats (pos etc)
	unit.gender = math.random(2) --1 = female, 2 = male --FOR BREEDING STUFF
	--set up timers & tables
	unit.lifetime = 0 --for timed stuff
	unit.seentiles = {};
	--tiles to move to
	unit.toMove = {unit.tile};
	--job int for setting tasks
	unit.job = 0
	unit.joblife = 0
	unit.delay = 0
	--resource carry
	unit.wood = 0
	unit.minerals = 0
	--genetic stuff
	unit.baseagressiveness = (parent1.baseagressiveness + parent2.baseagressiveness) / 2 + math.random(-1,1)
	unit.agressivenessmodifier = 0
	function unit.agressiveness() return unit.baseagressiveness + unit.agressivenessmodifier end
	unit.baseintelligence = (parent1.baseintelligence + parent2.baseintelligence) / 2 + math.random(-1,1)
	unit.intelligencemodifier = 0
	function unit.intelligence() return unit.baseintelligence + unit.intelligencemodifier end
	unit.baselaziness = (parent1.baselaziness + parent2.baselaziness) / 2 + math.random(-1,1)
	unit.lazinessmodifier = 0
	function unit.laziness() return unit.baselaziness + unit.lazinessmodifier end
	unit.basecharisma = (parent1.basecharisma + parent2.basecharisma) / 2 + math.random(-1,1)
	unit.charismamodifier = 0
	function unit.charisma() return unit.basecharisma + unit.charismamodifier end
	unit.basestrength = (parent1.basestrength + parent2.basestrength) / 2 + math.random(-1,1)
	unit.strengthmodifier = 0
	function unit.strength() return unit.basestrength + unit.strengthmodifier end
	unit.life = (parent1.life + parent2.life) / 2 + math.random(-10,10)
	unit.speed = (parent1.speed + parent2.speed) / 2 + (math.random(-5,5) / 10)
	unit.range = (parent1.range + parent2.range) / 2 + math.random(-1,1)
	unit.maxhp = math.floor(((unit.strength() * (math.log(unit.life,20) * (unit.laziness() + 1))) + 70 / 2))
	unit.hp = unit.maxhp * 2/3
	--relationships table for storing social data
	unit.relationships = {}
	
	--set up update function
	function unit:update()
		updateUnit(self)
	end
	function unit:attack(thing)
		local modifier = math.abs(self.hp) / self.maxhp * math.abs(self.agressiveness())
		if modifier > 0 then
			local attack = round(self.strength()^2 * modifier)
			if attack > 0 then
				thing.hp = thing.hp - attack
				print(self.name.." attacks "..thing.name.." for "..attack.." damage! "..thing.hp.."hp left.")
			end
			if thing.relationships[self.name] then
				thing.relationships[self.name] = thing.relationships[self.name] - thing.agressiveness() * math.random(3,12)
				thing.agressivenessmodifier = thing.agressivenessmodifier + (math.random(0,5) / 10)
			else
				thing.relationships[self.name] = thing.agressiveness() * math.random(3,12)
				thing.agressivenessmodifier = thing.agressivenessmodifier + (math.random(0,5) / 10)
			end
		end
	end
	function unit:canFit(tile) --check if a unit can fit in a tile
		if tile.space >= self.space then
			return true --yes, you can fit!
		end
		return false --hell no >_<
	end
	function unit:goTo(tile)
		if self:canFit(tile) then
			pathTo(self.tile, tile, worldTable, seentiles, self)
		end
	end
	function unit:destroy()
		for k,v in ipairs(self.tile.occupants) do
			if v == self then
				table.remove(self.tile.occupants, k); break
			end
		end
		for k,v in ipairs(teamTable[self.team].units) do
			if v == self then
				table.remove(teamTable[self.team].units, k); break
			end
		end
		for k,v in ipairs(worldTable.units) do
			if v == self then
				table.remove(worldTable.units, k); break
			end
		end
		print(self.name.." dead")
		self = {}
		self = nil
	end
	table.insert(tile.occupants, unit)
	table.insert(teamTable[unit.team].units, unit)
	teamTable[unit.team].totalunits = teamTable[unit.team].totalunits + 1
	table.insert(worldTable.units, unit)
	return unit
end

--terrain "unit" creation

function createTree(tile, size) --TREES
	if vegetationmat[tile.type] then
		local tree = {} --tree class construction
		tree.sprite = math.random(#vegetationmat[tile.type]) --equiv. of tile "type"
		tree.size = size or math.random(#vegetationmat[tile.type][tree.sprite]) --equiv of tile "kind"
		tree.class = "RESOURCE_TREE" --class derlatation type_kind again
		tree.tile = tile --references own tile for derivative stats (pos etc)
		tree.lifetime = 0 --for timed stuff :D
		--"genetic" traits
		tree.spacemult = math.random(1,3) --amount of space per size.
		tree.space = tree.size * tree.spacemult --how much space it takes up
		tree.growthinterval = math.random(3,5) --how many "hours" it takes to do a growth iteration
		tree.woodpersize = math.random(3,7) --how much maximum wood it will give per size.
		--assign update functions
		if vegetationmat[tile.type] == WOODS then
			function tree:update()
				self.space = self.spacemult * self.size
				self.lifetime = self.lifetime + 1
				if math.floor(self.lifetime / self.growthinterval) == self.lifetime / self.growthinterval then
					woodGrowth(self)
				end
				if round(self.size) <= 0 or not vegetationmat[self.tile.type] then
					self:destroy() --integrity check
				end
			end
		elseif vegetationmat[tile.type] == SCRUB then
			function tree:update()
				self.space = self.spacemult * self.size
				self.lifetime = self.lifetime + 1
				if math.floor(self.lifetime / self.growthinterval) == self.lifetime / self.growthinterval then
					scrubGrowth(self)
				end
				if round(self.size) <= 0 or not vegetationmat[self.tile.type] then
					self:destroy() --integrity check
				end
			end
		end
		function tree:destroy() --shows just how much i should have used self-hashing <_<
			self.tile.tag = "NORMAL"
			for k,v in ipairs(self.tile.occupants) do
				if v == self then
					table.remove(self.tile.occupants, k); break
				end
			end
			for k,v in ipairs(worldTable.vegetation) do
				if v == self then
					table.remove(worldTable.vegetation, k); break
				end
			end
			self = {}
			self = nil
		end
		table.insert(tree.tile.occupants, tree)
		table.insert(worldTable.vegetation, tree)
	end
	return tree
end

function createTreeReproduction(parent1, parent2, tile)
	if vegetationmat[tile.type] then
		local tree = {} --tree class construction
		tree.sprite = math.random(#vegetationmat[tile.type]) --equiv. of tile "type"
		tree.size = 1
		tree.class = "RESOURCE_TREE" --class declaration type_kind again
		tree.tile = tile --references own tile for derivative stats (pos etc)
		tree.lifetime = 0 --for timed stuff :D
		--"genetic" traits
		tree.spacemult = math.abs((parent1.spacemult + parent2.spacemult) / 2 + math.random(-1,1))
		tree.space = tree.spacemult
		tree.growthinterval = math.abs((parent1.growthinterval + parent2.growthinterval) / 2 + math.random(-1,1))
		tree.woodpersize = math.abs((parent1.woodpersize + parent2.woodpersize) / 2 + math.random(-1,1))
		--assign update functions
		if vegetationmat[tile.type] == WOODS then
			function tree:update()
				self.space = self.spacemult * self.size
				self.lifetime = self.lifetime + 1
				self.space = self.spacemult * self.size
				if math.floor(self.lifetime / self.growthinterval) == self.lifetime / self.growthinterval then
					woodGrowth(self)
				end
				if round(self.size) <= 0 or not vegetationmat[self.tile.type] then
					self:destroy() --integrity check
				end
			end
		elseif vegetationmat[tile.type] == SCRUB then
			function tree:update()
				self.space = self.spacemult * self.size
				self.lifetime = self.lifetime + 1
				self.space = self.spacemult * self.size
				if math.floor(self.lifetime / self.growthinterval) == self.lifetime / self.growthinterval then
					scrubGrowth(self)
				end
				if round(self.size) <= 0 or not vegetationmat[self.tile.type] then
					self:destroy() --integrity check
				end
			end
		end
		function tree:destroy() --shows just how much i should have used self-hashing <_<
			self.tile.tag = "NORMAL"
			for k,v in ipairs(self.tile.occupants) do
				if v == self then
					table.remove(self.tile.occupants, k); break
				end
			end
			for k,v in ipairs(worldTable.vegetation) do
				if v == self then
					table.remove(worldTable.vegetation, k); break
				end
			end
			self = {}
			self = nil
		end
		table.insert(tree.tile.occupants, tree)
		table.insert(worldTable.vegetation, tree)
	end
	return tree
end

function createMineral(tile) --MINERALS
	local rock = {} --rock class construction
	rock.size = math.random(#mineralmat) --equiv. of v "type"
	rock.sprite = math.random(#mineralmat[rock.size]) --equiv of v "kind"
	rock.space = 16 - rock.size * math.random(2) --how much space it takes up
	rock.class = "RESOURCE_MINERAL" --class declaration type_kind again
	--maybe put type in. mineral/ore/gem. i kind of like the genericism of it though.
	rock.tile = tile --references own tile for derivative stats (pos etc)
	table.insert(tile.occupants, rock)
	return rock
end
