function decideTasks(team)
	if #team.tasks < #team.units then
		while (#team.tasks < #team.units) do
			if #team.units < team.food / 50 and team.wood > 40 and team.food > 60 and math.random(2) == 1 then --comfortable levels
				table.insert(team.tasks, math.random(6,8)) --relax
			elseif math.random(-1,#team.units / 2) >= 1 and math.random(3) > 1 then --labour!
				if team.wood < (#team.units * #team.buildings) + 10 and math.random(2) == 1 then
					table.insert(team.tasks, 1)
				elseif team.food < #team.units * 40 + math.random(20) and team.wood > 2 and team:getNumBuilding("FARM") > 0 then
					table.insert(team.tasks, 4)
				elseif math.random(2) == 1 then
					table.insert(team.tasks, 9)
				else table.insert(team.tasks, 1) --cut wood anyway
				end
			elseif math.random(-1,#team.units / 3) == 1 and team.wood > 40 then --construction
				if team:getNumBuilding("HOUSE") <= #team.units / 2 and math.random(2) == 1 then
					table.insert(team.tasks, 2)
				elseif team:getNumBuilding("FARM") <= #team.units * 2/3 and math.random(2) == 1 then
					table.insert(team.tasks, 3)
				end
			elseif math.random(-1, #team.units) == 1 and #team.units > 3 then --patrol
				table.insert(team.tasks, 11)
			else
				local choose = math.random(7)
				if choose == 1 then
					table.insert(team.tasks, 8) --seek company
				elseif choose == 2 then
					table.insert(team.tasks, 7) --rest in house
				elseif choose == 3 then
					table.insert(team.tasks, 1) --get some wood
				elseif choose == 4 then --labour, but random
					if math.random(2) == 1 then
						table.insert(team.tasks, 1) --get some wood
					else
						table.insert(team.tasks, 4) --get some food
					end
				elseif choose == 5 then
					table.insert(team.tasks, math.random(5,7)) --explore or rest
				elseif choose == 6 then
					table.insert(team.tasks, math.random(2,3)) --random building
				else
					table.insert(team.tasks, math.random(11)) --random job
				end
			end
		end
	end
end

function updateTeam(self)
	decideTasks(self) -- do all the task descision stuff
	for num,unit in ipairs(self.units) do
		unit:update()
		unit.team = self.number
		if unit.hp <= 0 then
			unit:destroy()
		end
	end
	updateTeamString(self)
	for num,building in ipairs(self.buildings) do
		building:update()
	end
	if #self.units > 20 then --able to attack
		local attack = self; while attack == self do
		attack = teamTable[math.random(#teamTable)] end --get a random team to attack
		if self:getNetAgressiveness() > 20 then
			print("TEAM "..self.number.." IS ATTACKING TEAM "..attack.number)
			for k,v in ipairs(self.units) do
				--all go there
				pathTo(v.tile, attack.buildings[1].tile, worldTable, v.toMove, v)
			end
		end
	end
	if #self.units == 0 and #self.buildings == 0 then
		--self:destroy()
	end
end

function updateTeamString(self)
	self.string = " WOOD: "..math.floor(self.wood).." FOOD: "..self.food.." BLD: "..#self.buildings.." UNIT: "..#self.units.." | "
	for k,v in ipairs(self.tasks) do
		if jobs[v] then
			self.string = self.string..jobs[v] end
	end
end
